'
' DEMO USE API IN RQASM/NASM 
'
$ESCAPECHARS ON
$TYPECHECK ON
$INCLUDE "RAPIDQ.INC"
';  RQASM CODE
'Function GetFileHttp ptrUrlDownloadToFile ptrUrl ptrFileOut
';
'; DOWNLOAD FILE
'; -------------
'; RapidQ Model : GetFileHTTP = URLDownloadToFile (0, sURL, sToFile, 0, 0)
';
'         mov esi,     ptrUrl 
'         mov edi,     ptrFileOut
'; ---- CallApi URLDownloadToFileA
'         push         dword       0           ; rule : the last arg is pushed first
'         push         dword       0
'         push         edi
'         push         esi
'         push         dword       0
'         Call ptrUrlDownloadToFile
'; ---- End CallApi
'End Function
'; END RQASM CODE
' RQASM INC FILE
' ====================================================================================
$IFNDEF CALL_ASM_PROC_X
    $DEFINE CALL_ASM_PROC_X
    DECLARE FUNCTION CallAsmProc LIB "user32" ALIAS "CallWindowProcA" _
            (Proc AS LONG, A1 AS LONG, A2 AS LONG, A3 AS LONG, A4 AS LONG) AS LONG
$ENDIF
' ====================================================================================
' ----- ARRAY containing ASM GetFileHttp -----
DefByte GetFileHttpArray (0 To 34) = _
   {&H55,&H89,&HE5,&H8B,&H75,&H0C,&H8B,&H7D,&H10,&H68,&H00,&H00,&H00,&H00,&H68,&H00, _
    &H00,&H00,&H00,&H57,&H56,&H68,&H00,&H00,&H00,&H00,&HFF,&H55,&H08,&H89,&HEC,&H5D, _
    &HC2,&H10,&H00}
' ----- POINTER to use In CallAsmProc -----
DefInt ptrGetFileHttp = VarPtr (GetFileHttpArray(0))
' ----- RQ CALL GetFileHttp -----
Function GetFileHttp (ptrUrlDownloadToFile As Long, ptrUrl As Long, ptrFileOut As Long) As Long
    Result = CallAsmProc (ptrGetFileHttp, ptrUrlDownloadToFile, ptrUrl, ptrFileOut, 0)
End Function 
' ====================================================================================
' RQASM END INC FILE
'
Declare Function LoadLibrary Lib "kernel32" Alias "LoadLibraryA" (ByVal lpLibFileName As String) As Long
Declare Function GetProcAddress Lib "kernel32" Alias "GetProcAddress" (ByVal hModule As Long, ByVal lpProcName As String) As Long
'
DefInt hUrlMon_Dll = LoadLibrary ("Urlmon.Dll")
DefInt ptrUrlDownloadToFile = GetProcAddress (hUrlMon_Dll, "URLDownloadToFileA")
Print "hUrlMon_Dll = ";hUrlMon_Dll;"    ";"ptrUrlDownloadToFileA = ";ptrUrlDownloadToFile

DefStr sUrl = "http://www.google.com"
DefStr sFileOut = "Google.Html"
DefInt iResult = GetFileHttp (ptrUrlDownloadToFile, VarPtr(sUrl), VarPtr(sFileOut))

If iResult = 0 Then
    Print sUrl;"  OK  DOWNLOADED  TO  ";sFileOut
Else
    Print sUrl;"  FAILED  TO  BE  DOWNLOADED  TO  ";sFileOut
End If

' -------------------------------------------------------------
' EXIT CONSOLE
' ------------
DefStr sExit
Input "\n\n                    CR to QUIT \n\n", sExit
Application.Terminate
End
'
'
';PROC NAME : GETFILEHTTP
';
'; *** NASM CODE Generated by rqAsmToInc(V4.3 build 3) on 03-23-2005 at 16:52:30
'    bits 32
'; ---- Macros -----------------------------------
'    %define ptrUrlDownloadToFile [ebp+8]
'    %define ptrUrl [ebp+12]
'    %define ptrFileOut [ebp+16]
'; ---- End Macros -------------------------------
'  segment .text
'    start:
'    push ebp                            ; enter 0, 0
'    mov ebp, esp
'; *** End of RqAsm Automated Header
'; ===============================================
'; *** User's Code Begins Here
';
'; DOWNLOAD FILE
'; -------------
'; RQ Model : GetFileHTTP = URLDownloadToFile (0, sURL, sToFile, 0, 0)
';
'         mov esi,     ptrUrl
'         mov edi,     ptrFileOut
'; ---- CallApi URLDownloadToFileA
'         push         dword       0           ; rule : the last arg is pushed first
'         push         dword       0
'         push         edi
'         push         esi
'         push         dword       0
'         Call ptrUrlDownloadToFile
'; ---- End CallApi
';
'; *** End of User's Code
'; ==============================================
'; *** Automated RqAsm Footer
'    mov esp, ebp                        ; equiv to Leave
'    pop ebp
'    ret 16                              ; always 4 arguments with API CallWindowProcA + MeCodePtr
'; *** End of NASM Code
'
